// 012 u_interbase_blobs_raw
// 30 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_interbase_blobs_raw;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, ExtCtrls,
      Db, DBTables, Grids, DBGrids, DBCtrls, ComCtrls;

    type TForm1 = class(TForm)
    Database1: TDatabase;
    Query1: TQuery;
    DataSource1: TDataSource;
    Panel1: TPanel;
    create_table_: TButton;
    drop_table_: TButton;
    select_with_file_: TButton;
    insert_with_file_: TButton;
    insert_with_stream_: TButton;
    select_with_stream_: TButton;
    insert_many_with_stream_: TButton;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    select_many_with_stream_: TButton;
    insert_binary_with_stream_: TButton;
    select_binary_with_stream_: TButton;
                    procedure FormCreate(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure select_with_file_Click(Sender: TObject);
    procedure insert_with_file_Click(Sender: TObject);
    procedure insert_with_stream_Click(Sender: TObject);
    procedure select_with_stream_Click(Sender: TObject);
    procedure insert_many_with_stream_Click(Sender: TObject);
    procedure select_many_with_stream_Click(Sender: TObject);
    procedure insert_binary_with_stream_Click(Sender: TObject);
    procedure select_binary_with_stream_Click(Sender: TObject);
                    private
                    public
                  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display
      , u_file;

    {$R *.DFM}

    
    const k_log_path= 'log\';
            k_log_name= 'log_interbase_blobs_raw.txt';

    const k_file_path= '..\blobs_interbase\data_for_blob\';
            k_load_file_name= 'formations.txt';
            k_formation_interbase= 'formation_interbase.txt';
            k_save_file_name= 'save_formations.txt';

    // -- procedures

    procedure insert_with_file(p_id: Integer; p_file_name: String);
      begin
        with Form1, Query1, Sql do
        begin
          Clear;

          Add('INSERT INTO clients (c_id, c_blob)');
          Add('  VALUES ('+ IntToStr(p_id)+ ', :c_blob'+ ')');

          ParamByName('c_blob').LoadFromFile(p_file_name, ftBlob);

          ExecSql;
        end; // with Query1, Sql
        display_strings(Form1.Query1.Sql);
      end; // insert_with_file

    procedure select_with_file(p_id: Integer; p_file_name: String);
      begin
        with Form1, Query1, Sql do
        begin
          Close;
          Clear;
          Add('SELECT * FROM clients');
          Add('  WHERE c_id='+ IntToStr(p_id));
          Open;

          (FieldByName('c_blob') as tBlobField).SaveToFile(p_file_name);
        end; // with Form1, Query1, Sql
      end; // select_with_file

    procedure insert_with_stream(p_id: Integer; p_c_stream: tStream);
      begin
        display('Stream.Position: '+ IntToStr(p_c_stream.Position));
        display('Stream_size: '+ IntToStr(p_c_stream.Size));
        with Form1, Query1, Sql do
        begin
          Clear;

          Add('INSERT INTO clients (c_id, c_blob)');
          Add('  VALUES ('+ IntToStr(p_id)+ ', :c_blob'+ ')');

          // ParamByName('c_blob').LoadFromStream(p_c_stream, ftMemo);
          ParamByName('c_blob').LoadFromStream(p_c_stream, ftBlob);

          ExecSql;
        end; // with Query1, Sql
        display_strings(Form1.Query1.Sql);
        display('Stream.Position: '+ IntToStr(p_c_stream.Position));
      end; // insert_with_stream

    procedure select_with_stream(p_id: Integer; p_c_stream: tStream);
      begin
        with Form1, Query1, Sql do
        begin
          Close;
          Clear;
          Add('SELECT * FROM clients');
          Add('  WHERE c_id='+ IntToStr(p_id));
          Open;

          display('Stream.Position: '+ IntToStr(p_c_stream.Position));
          display('Stream_size: '+ IntToStr(p_c_stream.Size));
          (FieldByName('c_blob') as tBlobField).SaveToStream(p_c_stream);
        end; // with Query1, Sql
        display_strings(Form1.Query1.Sql);
        display('Stream.Position: '+ IntToStr(p_c_stream.Position));
      end; // select_with_stream

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_display_log(k_log_path+ k_log_name);
      end; // FormCreate

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        with Query1, Sql do
        begin
          Close;
          Clear;
          Add('CREATE TABLE clients');
          Add('   (                         ');
          Add('       c_id NUMERIC(5) NOT NULL PRIMARY KEY');
          Add('     , c_blob BLOB SUB_TYPE 0');
          Add('   )                         ');

          ExecSql;
        end; // with Query1, Sql

        display_line;
        display_strings(Query1.Sql);
      end; // create_table_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        with Query1, Sql do
        begin
          Close;
          Clear;
          Add('DROP TABLE clients');

          ExecSql;
        end; // with Query1, Sql

        display_line;
        display_strings(Query1.Sql);
      end; // drop_table_Click

    // -- files

    procedure TForm1.insert_with_file_Click(Sender: TObject);
      begin
        insert_with_file(103, k_file_path+ k_load_file_name);
      end; // insert_with_file_Click

    procedure TForm1.select_with_file_Click(Sender: TObject);
      begin
        select_with_file(103, k_file_path+ k_save_file_name);
      end; // select_with_file_Click

    procedure TForm1.insert_with_stream_Click(Sender: TObject);
      var l_c_memory_stream: tMemoryStream;
      begin
        l_c_memory_stream:= tMemoryStream.Create;
        Try
          l_c_memory_stream.LoadFromFile(k_file_path+ k_load_file_name);
          l_c_memory_stream.Seek(0,0);
          insert_with_stream(104, l_c_memory_stream);
        finally
          l_c_memory_stream.Free;
        end;
      end; // insert_with_stream_Click

    procedure TForm1.select_with_stream_Click(Sender: TObject);
      var l_c_memory_stream: tMemoryStream;
      begin
        l_c_memory_stream:= tMemoryStream.Create;
        select_with_stream(104, l_c_memory_stream);
        l_c_memory_stream.SaveToFile(k_file_path+ k_save_file_name);
        l_c_memory_stream.Free;
      end; // select_with_stream_Click

    // -- many records with blobs

    procedure TForm1.insert_many_with_stream_Click(Sender: TObject);
      var l_c_string_list: tStringList;
          l_id: Integer;
          l_line: String;
          l_c_string_stream: tStringStream;
      begin
        l_c_string_list:= tStringList.Create;
        l_c_string_list.LoadFromFile(k_file_path+ k_formation_interbase);

        for l_id:= 0 to 10 do
        begin
          l_line:= l_c_string_list[l_id];
          l_c_string_stream:= tStringStream.Create(l_line);
          insert_with_stream(1000+ l_id, l_c_string_stream);
          l_c_string_stream.Free;
        end;

        l_c_string_list.Free;
      end; // insert_many_with_stream_Click

    procedure TForm1.select_many_with_stream_Click(Sender: TObject);
      var l_c_string_stream: tStringStream;
          l_id: Integer;
      begin
        l_c_string_stream:= tStringStream.Create('');

        for l_id:= 0 to 10 do
        begin
          l_c_string_stream.Size:= 0;
          stop_display;
          select_with_stream(1000+ l_id, l_c_string_stream);
          start_display;

          display(l_c_string_stream.DataString);
        end;

        l_c_string_stream.Free;
      end; // select_many_with_stream_Click

    // -- free format

    procedure TForm1.insert_binary_with_stream_Click(Sender: TObject);
      var l_c_memory_stream: tMemoryStream;
          l_my_integer: Integer;
          l_my_double: Double;
          l_my_date: tDateTime;
          l_my_boolean: Boolean;
          l_my_string: String;
          l_string_length: Integer;
      begin
        l_c_memory_stream:= tMemoryStream.Create;

        l_my_integer:= $12340000;
        l_c_memory_stream.Write(l_my_integer, 4);

        l_my_double:= 3.14;
        l_c_memory_stream.Write(l_my_double, SizeOf(l_my_double));

        l_my_date:= Now;
        l_c_memory_stream.Write(l_my_date, SizeOf(l_my_date));

        l_my_boolean:= True;
        l_c_memory_stream.Write(l_my_boolean, 1);

        l_my_string:= 'aha';
        l_string_length:= Length(l_my_string);
        l_c_memory_stream.Write(l_string_length, 4);
        if l_string_length> 0
          then l_c_memory_stream.Write(l_my_string[1], l_string_length);

        display_line;
        display('Size '+ IntToStr(l_c_memory_stream.Position));

        l_c_memory_stream.Seek(0,0);
        insert_with_stream(105, l_c_memory_stream);
        // l_c_memory_stream.SaveToFile(k_file_path+ 'jiji.bin');

        l_c_memory_stream.Free;
      end; // insert_binary_with_stream_Click

    procedure TForm1.select_binary_with_stream_Click(Sender: TObject);
      var l_c_memory_stream: tMemoryStream;

          l_my_integer: Integer;
          l_my_double: Double;
          l_my_date: tDateTime;
          l_my_boolean: Boolean;
          l_my_string: String;
          l_string_length: Integer;
      begin
        l_c_memory_stream:= tMemoryStream.Create;
        select_with_stream(105, l_c_memory_stream);

        display_line;
        display('Size '+ IntToStr(l_c_memory_stream.Position));

        l_c_memory_stream.Seek(0,0);

        if l_c_memory_stream.Read(l_my_integer, 4)= 4
          then display('Integer: '+ IntToStr(l_my_integer));

        if l_c_memory_stream.Read(l_my_double, SizeOf(l_my_double))= 8
          then display('Double: '+ FloatToStr(l_my_double));

        if l_c_memory_stream.Read(l_my_date, SizeOf(l_my_date))= 8
          then display('Date '+ DateTimeToStr(l_my_date));

        if l_c_memory_stream.Read(l_my_boolean, 1)= 1
          then
            if l_my_boolean
              then display('True')
              else display('False');

        if l_c_memory_stream.Read(l_string_length, 4)= 4
          then
            if l_string_length> 0
              then begin
                  SetLength(l_my_string, l_string_length);
                  l_c_memory_stream.Read(l_my_string[1], l_string_length);
                  display('String '+ l_my_string);
                end;

        display('Stream.Position: '+ IntToStr(l_c_memory_stream.Position));
        l_c_memory_stream.Free;
      end; // select_binary_with_stream_Click

    end.


